package discovery

import (
	"fmt"
	"net"

	discoveryM "git.loafle.net/overflow/overflow_commons_go/modules/discovery/model"
	"git.loafle.net/overflow/overflow_discovery/discovery/ipv4"
	"git.loafle.net/overflow/overflow_discovery/discovery/ipv6"
)

func scanPort(host *discoveryM.Host, dp *discoveryM.DiscoveryPort, resultChan chan interface{}, errChan chan error, doneChan chan<- struct{}, stopChan chan struct{}) {
	defer func() {
		doneChan <- struct{}{}
	}()

	_, ipNet, err := net.ParseCIDR(host.Zone.Network)
	if nil != err {
		errChan <- err
		return
	}
	switch len(ipNet.IP) {
	case net.IPv4len:
		ipv4.ScanPort(host, dp, resultChan, errChan, stopChan)
	case net.IPv6len:
		ipv6.ScanPort(host, dp, resultChan, errChan, stopChan)

	default:
		errChan <- fmt.Errorf("Discovery: Not supported ip length")
		return
	}
}
